#!/bin/bash

expected="/bin/true /bin/false"

function test_makefile
{
	tmp1=`$with_fs_tempfile` || return 1
	echo '
test.out: '$expected'
	@echo '$1'
' > $tmp1
	make -f $tmp1
	rm $tmp1
}

tmp=`test_makefile "\\$^"`
echo "[MAKE] For \$^ output is $tmp" >> $LOG
if test "$tmp" = "$expected"
then
	echo "\$^"
	exit 0
fi

tmp=`test_makefile "\\$?"`
echo "[MAKE] For \$? output is $tmp" >> $LOG
if test "$tmp" = "$expected"
then
	echo "\$?"
	exit 0
fi

tmp=`test_makefile "\\$*"`
echo "[MAKE] For \$* output is $tmp" >> $LOG
if test "$tmp" = "$expected"
then
	echo "\$*"
	exit 0
fi

exit 1
