#!/bin/bash
# This lib detects whether snprintf works
. lib/compile.lib

	q=`echo '
#include <stdlib.h>
#include <stdio.h>
int main() {
	char buff[9];
	char *s = buff+2;

	// build a fence
	buff[0] = 0;
	buff[1] = 65;
	buff[7] = 66;
	buff[8] = 0;

	snprintf(s, 4, "%d", 123456);
	printf("%s\n", s);
	return 0;
}
	'  | test_compile 2>/dev/null`

	echo "[detect_snprint] Trying 123456 with $1, $CFLAGS, $LDFLAGS ->$q" >> $LOG

if test "$q" = "123"
then
	echo ""
	exit 0
fi

if test "$q" = "1234"
then
	echo ""
	echo "[detect_snprint] found an unsafe implementation :)" >> $LOG
	exit 0
fi

# Not found, use os_dep replacement
echo "//"
exit 0


