#!/bin/bash

function try_dlc {
	q=`echo '
#include <'$1'dl-compat.h>
#include <'$1'dl-flags.h>
int main() {
	dlopen(0, RTLD_NOW);
	printf("OK");
	return 0;
}
	'  | test_compile`

	echo "[core] Trying dl-compat with $1, $LDFLAGS ->$q" >> $LOG
	
	if test "$q" = "OK"
	then
		return 0
	fi

	return 1
}

function dlc_find {
	LDFLAGS=-ldl-compat
	try_dlc "" 2>/dev/null && echo "|" $LDFLAGS && return
	LDFLAGS=libdl-compat.dll
	try_dlc "" 2>/dev/null && echo "|" $LDFLAGS && return
	PREFIX=$1
	CFLAGS="-I${PREFIX}/include"
	LDFLAGS="-L${PREFIX}/lib -L${PREFIX}/bin -ldl-compat"
	try_dlc "" 2>/dev/null && echo $CFLAGS "|" $LDFLAGS "|" $PREFIX && return
	CFLAGS="-I${PREFIX}/include"
	LDFLAGS="${PREFIX}/bin/libdl-compat.dll"
	try_dlc "" 2>/dev/null && echo $CFLAGS "|" $LDFLAGS "|" $PREFIX && return
}

. lib/compile.lib
dlc_find $*
