#!/bin/bash

#Please read Readme-config

function try_lua {
	q=`echo '
#include <'$1'lua.h>
#include <'$1'lauxlib.h>
int main() {
	lua_State *state;
	state = lua_open();
	luaL_loadfile(state, "nothing");
	printf("OK");
	return 0;
}
	'  | test_compile`

	echo "[scripts] Trying lua with $1, $LDFLAGS -> $q" >> $LOG

	if test "$q" = "OK"
	then
		return 0
	fi

	return 1
}

function lua_find {
	LDFLAGS="-llua -llualib -lm $with_sys_ldl"
	try_lua "" 2>/dev/null  && echo "|" $LDFLAGS && return

	# lualib doesn't exist in lua 5.1.1
	LDFLAGS="-llua -lm $with_sys_ldl"
	try_lua "" 2>/dev/null  && echo "|" $LDFLAGS && return

	#This one is for OSX (by Bjarni)
	LDFLAGS="-L/sw/lib/ -llualib -llua -lm $with_sys_ldl"
	try_lua "/sw/include/" 2>/dev/null  && echo "|" $LDFLAGS && return

	for n in `ls -d /usr/local/include/lua* /usr/include/lua* 2>/dev/null`
	do
		LDFLAGS=`echo "-l$n -l${n}lib -lm $with_sys_ldl" | sed s@/usr.*include/@@`
		try_lua "$n/" 2>/dev/null  && echo -I$n "|" $LDFLAGS && return
		LDFLAGS=`echo "-l$n -l${n} -lm $with_sys_ldl" | sed s@/usr.*include/@@`
		try_lua "$n/" 2>/dev/null  && echo -I$n "|" $LDFLAGS && return
		LDFLAGS="-llua -llualib -lm $with_sys_ldl"
		try_lua "$n/" 2>/dev/null && echo -I$n "|" $LDFLAGS && return
		LDFLAGS="-llua50 -llualib50 -lm $with_sys_ldl"
		try_lua "$n/" 2>/dev/null && echo -I$n "|" $LDFLAGS && return

	done
}

#remove these before you start using it
. lib/compile.lib
lua_find
