#!/bin/bash

#Please read Readme-config

function try_tcl {
	q=`echo '
#include <'$1'tcl.h>
int main() {
	Tcl_Obj *res;
	Tcl_Interp *interp;

	interp = Tcl_CreateInterp();
	printf("OK");
	return 0;
}
	'  | test_compile`

	echo "[scripts] Trying tcl with $1, $LDFLAGS ->$q" >> $LOG

	if test "$q" = "OK"
	then
		return 0
	fi

	return 1
}

function tclconfig {
	echo '
		proc tclConfigFile {} {
			set d [info library]
			set f [file join $d "tclConfig.sh"]
			if {[file exists $f]} {return $f}

			set d [file dirname $d]
			set f [file join $d "tclConfig.sh"]
			if {[file exists $f]} {return $f}

			set d [file dirname $d]
			set f [file join $d "tclConfig.sh"]
			if {[file exists $f]} {return $f}

			set d [file dirname $d]
			set f [file join $d "tclConfig.sh"]
			if {[file exists $f]} {return $f}
		}

		puts [tclConfigFile]

	' | tclsh
}

function tcl_find {
	LDFLAGS=-ltcl
	try_tcl "" 2>/dev/null && echo "|" $LDFLAGS && return
	LDFLAGS=-ltcl84
	try_tcl "" 2>/dev/null && echo "|" $LDFLAGS && return
	LDFLAGS=-ltcl8.4
	try_tcl "" 2>/dev/null && echo "|" $LDFLAGS && return

	for n in `ls -d /usr/local/include/tcl* /usr/include/tcl* 2>/dev/null`
	do
		LDFLAGS=`echo "-l$n" | sed s@/usr.*include/@@`
		try_tcl "$n/" 2>/dev/null  && echo -I$n "|" $LDFLAGS && return
		LDFLAGS=-ltcl
		try_tcl "$n/" 2>/dev/null && echo -I$n "|" $LDFLAGS && return
	done

	# trying to get info from tcl itself (using tclConfig.sh)
	tclcfg=`tclconfig 2>/dev/null`
	if ! test -z "$tclcfg"
	then
	    . $tclcfg
    	    LDFLAGS=$TCL_LIB_SPEC
	    CFLAGS=$TCL_INCLUDE_SPEC
	    try_tcl "" 2>/dev/null && echo $CFLAGS "|" $LDFLAGS
	fi
}

#remove these before you start using it
. lib/compile.lib
tcl_find
