#!/bin/sh

echo '
src_root = ../..
include $(src_root)/Makefile.config
include $(src_root)/Makefile.dirs
include $(src_modules)/Makefile.configured
'

echo "# Include static rules for scripts "
for n in $1
do
	echo "include \$(src_modules)/$n-static.make"
done

echo '
CFLAGS = $(GPMI_CFLAGS) -I$(src_root) -DGPMI_ROOT=\"${src_root}\" \
         $(GPMI_WITH_FPIC) -Dtest_static -I../example-scripts -I$(src_packages)

LDFLAGS = $(GPMI_WITH_RDYNAMIC) $(src_gpmi)/libgpmi.a  $(GPMI_WITH_LDL) $(GPMI_LDFLAGS)
'

if test "$2" = "windlc"
then
	echo '
# hack needed until mingw win32api is fixed
LDFLAGS = ${LDFLAGS} c:/windows/system32/msvcrt.dll
'
fi
 

echo -n '
include Makefile.am

OUTPUT_FILE = $(FILE_NAME)$(GPMI_EXE_EXT)

all: $(OUTPUT_FILE)

include Makefile.dep

OBJS = $(SOURCE:.c=.o)

ARCHIVES ='

for n in gpmi_scripts timer filter qparse bgproc
do
	echo -n " \$(src_packages)/$n.a"
done

echo '$(GPMI_STATIC_MODULES)

$(OUTPUT_FILE): $(OBJS)
	$(GPMI_CC) $(OBJS) $(ARCHIVE_OBJS) -o $(OUTPUT_FILE) $(LDFLAGS)

clean:
	rm -rf $(OUTPUT_FILE) $(OBJS)

mrproper: clean

depend:
	$(src_config)/gpmi-config --dep $(CFLAGS) -- $(SOURCE)

'

echo "# local rules"
for n in $3
do
echo '
'$n'.o: ../example-scripts/main.c
	$(GPMI_CC) -c $(CFLAGS) ../example-scripts/'$n'.c -o $@
'
done
