/*
    hash 1.0.0 simple hash tables with linked lists
    Copyright (C) 2004 Tibor `Igor2` Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Author: igor2gpmi@peticio.hu
*/

/* This file contains helper routines for searching buckets with multiple records */

#include <stdlib.h>
#include "hash.h"

const void *hash_find_next(struct hash_t *h, const void *key, struct hdata_t **a)
{
	*a = (*a)->next;
	return (*a == NULL) ? NULL : (*a)->data;
}

const void *hash_find_first(struct hash_t *h, const void *key, struct hdata_t **a)
{
	*a = hash_find_(h, key);
	return (*a == NULL) ? NULL : (*a)->data;
}
