/*
    libgpmi - General Package/Module Interface - cli module
    Copyright (C) 2006-2007 Tibor 'Igor2' Palinkas & glx
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SCRIPT_MODULE_CLI_H
#define SCRIPT_MODULE_CLI_H

//#define cli_dprintf(x...) fprintf(stderr, x);

#include <gpmi_config.h>
#ifndef cli_dprintf
#	ifndef NO_VARARG_MACRO
		/* Safe way to ignore parameters */
		#define cli_dprintf(x...)
#	else
		/* Less safer but more portable */
		#define cli_dprintf
#	endif
#endif

#include "cli_core.h"
#include "packages/gpmi_scripts.h"

typedef struct Cli_ClientData {
	cli_t *c;
	int read_timeout;
} Cli_ClientData;

int  Cli_Initialize(void **client_data);
void Cli_Destroy(void **client_data);
void Cli_RegisterCommand(void *client_data, const char *name);
int  Cli_LoadScript(void *client_data, const char *filename);
char *Cli_GetExtension();
int  Cli_Rehash(void *client_data);
void Cli_RunFunction(void *client_data, const char *function, int argc, const char **argv);

int Cli_DynamicPackageCommand(char *command_string);
#endif /* SCRIPT_MODULE_CLI_H */
