/*
    libgpmi - General Package/Module Interface - GHLI module
    Copyright (C) 2005-2007 Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SCRIPT_MODULE_GHLI_H
#define SCRIPT_MODULE_GHLI_H

#include <ghli.h>
#include "packages/gpmi_scripts.h"

typedef struct GHLI_ClientData {
	ghli_t *h;
	char *script_name;
	const gpmi_package *loading;
} GHLI_ClientData;

int  GHLI_Initialize(void **client_data);
void GHLI_Destroy(void **client_data);
void GHLI_RegisterCommand(void *client_data, const char *name);
int  GHLI_LoadScript(void *client_data, const char *filename);
char *GHLI_GetExtension();
int  GHLI_Rehash(void *client_data);
void GHLI_RunFunction(void *client_data, const char *function, int argc, const char **argv);
void GHLI_SetPkg(void *client_data, const gpmi_package *package);

// GHLI.c
void GHLI_ReportGHLIError(GHLI_ClientData *GHLI_MyData, int error);

#endif /* SCRIPT_MODULE_GHLI_H */
