/*
    libgpmi - General Package/Module Interface - tcl module
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SCRIPT_MODULE_TCL_H
#define SCRIPT_MODULE_TCL_H

#include <tcl.h>
#include "packages/gpmi_scripts.h"

typedef struct TCL_ClientData {
	Tcl_Interp *interp;
	char *script_name;
} TCL_ClientData;

int  TCL_Initialize(void **client_data);
void TCL_Destroy(void **client_data);
void TCL_RegisterCommand(void *client_data, const char *name);
int  TCL_LoadScript(void *client_data, const char *filename);
char *TCL_GetExtension();
int  TCL_Rehash(void *client_data);
void TCL_RunFunction(void *client_data, const char *function, int argc, const char **argv);

// tcl.c
void TCL_ReportTclError(TCL_ClientData *TCL_MyData);

#endif /* SCRIPT_MODULE_TCL_H */
