#include <stdio.h>
#include "gpmi.h"
#include "../example.h"

/**
 * This one is the Big Init routine, called only once, when the lib is loaded
 * Returns 0 if ok. For non-zero return, the package will be killed and
 * error is returned to the loader module or app.
 */
int PKG_FUNC(init)(void)
{
	printf("Example-pkg: big init\n");

	/* Have to init keywords */
	Example_colors_kw = gpmi_keyword_import("Example_colors", gpmi_keyword_type_integer, example_colors_ska);
	printf("Example-pkg: inited example colors: " PRINTF_PTR " != " PRINTF_PTR "\n", STD_PRINTFP_CAST Example_colors_kw, STD_PRINTFP_CAST NULL);
	return 0;
}

/**
 * This one is the Big UnInit routine, called only once, before the lib
 * is unloaded.
 */
void PKG_FUNC(uninit)(void)
{
	/* Have to clean up keywords initialized by the package */
	gpmi_keyword_destroy(Example_colors_kw);

	printf("Example-pkg: big uninit\n");
}


/**
 * This one is the small init routine, called when the package is
 * assigned to a module (or the app)
 */
void PKG_FUNC(register)(void)
{
	printf("Example-pkg: register\n");
}


/**
 * Version checking routine
 */
int PKG_FUNC(checkver)(int requested)
{
	printf("Example-pkg: version check\n");
	return 0;
}

