/*
    libgpmi - General Package/Module Interface - gpmi_scripts package
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef MODULE_EVENTS_H
#define MODULE_EVENTS_H
typedef struct module_event module_event;

typedef void module_events_callback(void *handle, void *event_data);
typedef void module_free_data_proc(void *data); //! Called to free the 'event_data' from module_events_call
typedef int  module_compare_data_proc(void *data1, void *data2); //! Called from unbind, to check if 2 event_data's are the same

/* Each module id has a signle linked list of event data */
struct module_event {
	void *data;
	module_event *next;
	int called;
} ;

/* Structure to store all the events */
typedef struct module_events {
	module_event **events;
	int allocated;
} module_events;

module_events *module_events_init();
int module_events_uninit(module_events *events, module_free_data_proc *proc);
void module_events_bind(module_events *events, int event_id, void *event_data);
int module_events_unbind(module_events *events, int event_id, void *event_data, module_compare_data_proc *proc_match, module_free_data_proc *proc);
int module_events_call(module_events *events, int event_id, module_events_callback *callback, void *handle);
#endif /* MODULE_EVENTS_H */
