# This is an example how to use hash package from tcl. This script is
# also part of the regression test

proc RunData {data} {}

PkgLoad hash 0

set hash [gpmi_hash_create 8]
puts "table: $hash != 0"

puts "Recno: [gpmi_hash_stat_recno $hash]"

gpmi_hash_store $hash red R
gpmi_hash_store $hash green G
gpmi_hash_store $hash blue B

puts "Recno: [gpmi_hash_stat_recno $hash] == 3"

puts "max records per node: [gpmi_hash_stat_max_node $hash]"
puts "avg records per node: [gpmi_hash_stat_avg_node $hash]"
puts "memory: [gpmi_hash_stat_mem $hash] bytes are wasted"

puts "Red is [gpmi_hash_find $hash red] == R"

puts "Now a rehash..."
set hash [gpmi_hash_rehash $hash 256]
puts "table: $hash != 0x0"

puts "max records per node: [gpmi_hash_stat_max_node $hash]"
puts "avg records per node: [gpmi_hash_stat_avg_node $hash]"
puts "memory: [gpmi_hash_stat_mem $hash] bytes are wasted"

puts "Green is [gpmi_hash_find $hash green] == G"


