#!/bin/bash

EXE="../../example-app/example-scripts/example-scripts"
WRAPPER="../../gpmi_src_wrap.sh"

if ! test -x $EXE
then
	EXE="$EXE.exe"
	if ! test -x $EXE
	then
		echo "ERROR: example-scripts not found. Please make before running the test!"
		exit
	fi
fi

if test -e "../../modules/tcl.dep"
then
	LANG="tcl"
elif test -e "../../modules/lua.dep"
then
	LANG="lua"
elif test -e "../../modules/ruby.dep"
then
	LANG="ruby"
else
	echo "ERROR: no language available to run the package-tests (needs TCL or LUA or RUBY)"
	exit
fi

printf "Testing hash package...                 "
# make sure we won't use an old out
rm -f out
$WRAPPER $EMULATOR $EXE $LANG package_hash > out 2> /dev/null
../test.awk hash.OK < out || fail=1
rm -f out


printf "Testing keywords package...             "
# make sure we won't use an old out
rm -f out
$WRAPPER $EMULATOR $EXE $LANG package_keywords > out 2> /dev/null
../test.awk keywords.OK < out || fail=1
rm -f out


if ! test -z "$fail"
then
	false
else
	true
fi
