/*
    libgpmi - General Package/Module Interface - wrapgen
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "wrapgen_keywords.h"

hash_t *keywords = NULL;

/* Warning: multiline macro! */
#define Warning(x...)		fprintf(stderr, "Warning: "); fprintf(stderr, x);

void keyword_init()
{
	keywords = hash_create(128, NULL);
}

int keyword_store(char *name, char *type_)
{
	const int *type;
	int *temp;
	int type_tmp;

	type_tmp = FindType(type_);
	if (type_tmp == type_keyword) {
		Warning("Invalid type for keyword %s: %s\n", name, type_);
		return -1;
	}

	type = hash_find(keywords, name);
	if (type != NULL) {
		if (*type != type_tmp) {
			Warning("Redefinition of keyword %s for a different type\n", name);
		}
		else {
			Warning("Redefinition of keyword %s\n", name);
		}
		return 2;
	}

	temp = malloc(4);
	*temp = type_tmp;
	hash_store(keywords, name, temp);
	return 0;
}

int keyword_find(char *name)
{
	const int *type;

	type = hash_find(keywords, name);

	if (type == NULL)
		return -1;

	return *type;
}
