/*
    libgpmi - General Package/Module Interface - wrapgen
    Copyright (C) 2005-2007 Patric 'TrueLight' Stout & Tibor 'Igor2' Palinkas
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef WRAPGEN_PARSER_H
#define WRAPGEN_PARSER_H
#include <stdio.h>

extern char *type_names[];							//! names of valid types

typedef enum types {
	type_keyword = 0,
	type_int     = 1,
	type_string  = 2,
	type_double  = 3,
	type_void    = 4,
	type_uint		 = 5,
	type_ptr     = 6,
	type_uchar   = 7,
	type_char    = 8,
} types ;

#define number_of_types 9

typedef enum type_flags {
	flag_dynamic  = 1,
	flag_multiple = 2,
	flag_const    = 4,
	flag_direct		= 8,
} type_flags;

typedef enum file_cmds {
	close_files,
	open_files,
} file_cmds;

void split(char *string, char *first, char *second);	//! Split a line in two words
int FindType(char *name); 														//! Finds a type by name
int GetTypeFlags(char *type, int line);								//! resolve type prefixes
void GenWrapper(FILE *input, void *generator, void *newproc, void *gotparam, void *fileoperations, const char *section);
//!< parse a list file and callback the wrapper generator functions

#endif /* WRAPGEN_PARSER_H */

